#$1 username for github account
#$2 password

#scripts to obtain the lists of projects with Android in their description, readme or name. 
#input (date_ranges_list.txt file, placed in same folder, with date ranges for projects, to avoid obtaining more than the results limit of the API)
#output: list of repository names in file proj_names.txt


CURR_DATE_RANGE="<2010-01-01"
ACCEPT_COMMAND="'Accept: application/vnd.github.v3.text-match+json'"
USER=$1
PASSWORD=$2


echo "" > proj_names.txt

while read p; do
	CURR_DATE_RANGE=$p
	echo "Executing script for date range $CURR_DATE_RANGE"


	CURRENT_PAGE="1"


	N_ITEMS=`curl -u $USER:$PASSWORD -H 'Accept: application/vnd.github.v3.text-match+json' 'https://api.github.com/search/repositories?q=android+language:java+created:"'$CURR_DATE_RANGE'"&sort=stars&order=desc&page='$CURRENT_PAGE'' | jsawk 'return this.total_count'` > res1.txt


	N_PAGES=$(($N_ITEMS / 30))
	N_PAGES=$(($N_PAGES + 1))
	echo $N_PAGES

	for (( i=1; i <= $N_PAGES; i++ ))
	do
		CURRENT_PAGE=$i	
		echo "page $CURRENT_PAGE of $N_PAGES"
		curl -u $USER:$PASSWORD -H 'Accept: application/vnd.github.v3.text-match+json' 'https://api.github.com/search/repositories?q=android+language:java+created:"'$CURR_DATE_RANGE'"&sort=stars&order=desc&page='$CURRENT_PAGE'' | jsawk 'return this.items' | jsawk 'return this.full_name' | tr -d '"[]' | tr "," "\n" >> proj_names.txt

		sleep 2s
	done

done <date_ranges_list.txt
