#script to obtain the Android projects (starting from a list of android projects) featuring a given keyword
#input: $1 keyword to search, $2 username for github account, $3 password for github account, $4 dummy parameter to split execution in different result files,
#	file_list_$ITERATION (in same folder of this script), part of the total list of Android files (extracted with script_search.sh) to examine
#output: test files found inside projects, and project names corresponding to the given keyword

ACCEPT_COMMAND="'Accept: application/vnd.github.v3.text-match+json'"

KEYWORD=$1
USER=$2
PASSWORD=$3
ITERATION=$4

COUNT="0"


echo "" #> script2results/proj_test_files_"$KEYWORD"_"$ITERATION".txt

while read p; do
	CURR_REPOSITORY=$p
	CURRENT_PAGE="1"
	echo "searching $KEYWORD in repository $p"
	curl -u $USER:$PASSWORD -H 'Accept: application/vnd.github.v3.text-match+json' 'https://api.github.com/search/code?q='$KEYWORD'+language:java+repo:'$CURR_REPOSITORY'&page='$CURRENT_PAGE'' > script2tmp/tmp_json_res_$ITERATION.txt

	ERRORS=`cat script2tmp/tmp_json_res_$ITERATION.txt | jsawk 'return this.errors'` 
	if [ -n "$ERRORS" ] 
	then
		echo $CURR_REPOSITORY: `cat script2tmp/tmp_json_res_$ITERATION.txt | jsawk 'return this.errors' | jsawk 'return this.message'` >> script2logs/proj_test_files_"$KEYWORD"_"$ITERATION".txt
	fi

	N_OCCURRENCES=`cat script2tmp/tmp_json_res_$ITERATION.txt | jsawk 'return this.total_count'`
 	if [ "$N_OCCURRENCES" -ne "0" ]
	then
		echo "found $N_OCCURRENCES"
		echo "$CURR_REPOSITORY - $N_OCCURRENCES" >> script2results/proj_test_files_"$KEYWORD"_"$ITERATION".txt

		N_PAGES=$(($N_OCCURRENCES / 30))
		N_PAGES=$(($N_PAGES + 1))

		if [ $N_PAGES -ge 31 ]
		then
			echo "$CURR_REPOSITORY: more than 1000 files found" >> script2logs/proj_test_files_"$KEYWORD"_"$ITERATION".txt
			N_PAGES=30
		fi

		cat script2tmp/tmp_json_res_$ITERATION.txt | jsawk 'return this.items' | jsawk 'return this.name' >> script2results/proj_test_files_"$KEYWORD"_"$ITERATION".txt
		for (( i=2; i <= $N_PAGES; i++ ))
		do
			CURRENT_PAGE=$(( $i ))
			echo processing page $CURRENT_PAGE
			curl -u $USER:$PASSWORD -H 'Accept: application/vnd.github.v3.text-match+json' 'https://api.github.com/search/code?q='$KEYWORD'+language:java+repo:'$CURR_REPOSITORY'&page='$CURRENT_PAGE'' | jsawk 'return this.items' | jsawk 'return this.name' >> script2results/proj_test_files_"$KEYWORD"_"$ITERATION".txt
			sleep 2s
		done
		echo "" >> script2results/proj_test_files_"$KEYWORD"_"$ITERATION".txt
		COUNT=$(( $COUNT + 1 ))
	fi
	sleep 2s
done < file_list_$ITERATION.txt

echo "TOTAL = $COUNT" >> script2results/proj_test_files_"$KEYWORD"_"$ITERATION".txt
