#script for extracting stats for tab1
#average number of test classes
#average normalized LOC
#average number of versions

PROJECTS_LIST_FILE=$1
KEYWORD_SEARCHED=$2
STARTING_FOLDER=$3
OUTPUT_FILE=$4
SCRIPT_FOLDER="$PWD"

TOTAL_PROJECTS=` cat $PROJECTS_LIST_FILE | wc -l `



CURRENT="0"

echo "" > results.txt

while read line; do

	rm $SCRIPT_FOLDER/current_vtag_test_files.txt
	rm $SCRIPT_FOLDER/current_vtag_test_files_prefilter.txt

	echo "doing $CURRENT of $TOTAL_PROJECTS"

	PROJ_NAME=$line
	cd $STARTING_FOLDER/$PROJ_NAME

	git tag | xargs -I@ git log --format=format:"%ai @%n" -1 @ | sort | awk '{print $4}' > $STARTING_FOLDER/tags.txt
	NUMBER_TAGS_CURRENT_REPOSITORY=`cat $STARTING_FOLDER/tags.txt | wc -l`
	NUMBER_TAGS_CURRENT_REPOSITORY=$(( $NUMBER_TAGS_CURRENT_REPOSITORY + 1 ))

	echo $NUMBER_TAGS_CURRENT_REPOSITORY

	rg -l -i "$KEYWORD_SEARCHED" $STARTING_FOLDER/$PROJ_NAME | awk -F "." '$NF == "java" {print $0}' > $SCRIPT_FOLDER/current_vtag_test_files_prefilter.txt

	cat $SCRIPT_FOLDER/current_vtag_test_files_prefilter.txt


	while read test_file; do
			
			#1 the file contains "test" in its path

			found_test=` echo $test_file | grep -i "test"  `
			if [ "$found_test" = "" ]; then
				echo "" 
			else
				found_keyword_after_comments=` cat $test_file | $SCRIPT_FOLDER/script.sed | grep "$KEYWORD_SEARCHED" `


				#2 the file, after all row and block comments are removed, contains anyway the keyword searched
				if [ "$found_keyword_after_comments" = "" ]; then
					echo "$test_file doesn't contain keyword $KEYWORD_SEARCHED after removing comments"
				else 
					echo "$test_file contains keyword $KEYWORD_SEARCHED after removing comments" 
					echo $test_file >> $SCRIPT_FOLDER/current_vtag_test_files.txt
				fi						
			fi	



	done < $SCRIPT_FOLDER/current_vtag_test_files_prefilter.txt




	NUMBER_VTAG_TEST_FILES=`cat $SCRIPT_FOLDER/current_vtag_test_files.txt | wc -l`



	find . -name *.java > $SCRIPT_FOLDER/all_files.txt
	cat $SCRIPT_FOLDER/all_files.txt | grep -v " " > $SCRIPT_FOLDER/all_files_no_spaces.txt
	cat $SCRIPT_FOLDER/all_files.txt | grep " " > $SCRIPT_FOLDER/all_files_with_spaces.txt
	

	TOTAL_LINES_OF_APP_CODE="0"

	TOTAL_LINES_OF_TEST_CODE="0"

	while read line3; do
		#echo $line3
		LINES_OF_CURRENT_FILE=$(cloc --quiet "$line3" | awk '$1 == "Java" {print $3+$4+$5}')
		TOTAL_LINES_OF_TEST_CODE=$(( $TOTAL_LINES_OF_TEST_CODE+$LINES_OF_CURRENT_FILE ))
	done < $SCRIPT_FOLDER/current_vtag_test_files.txt

	TOTAL_LINES_OF_APP_CODE=$(cloc --quiet `cat $SCRIPT_FOLDER/all_files_no_spaces.txt` | awk '$1 == "Java" {print $3+$4+$5}')
	if [ -s $SCRIPT_FOLDER/all_files_with_spaces.txt ]
	then
     		echo "File not empty"
		while read line2; do
			#echo $line2
			LINES_OF_CURRENT_FILE=$(cloc --quiet "$line2" | awk '$1 == "Java" {print $3+$4+$5}')
			TOTAL_LINES_OF_APP_CODE=$(( $TOTAL_LINES_OF_APP_CODE+$LINES_OF_CURRENT_FILE ))
		done <  $SCRIPT_FOLDER/all_files_with_spaces.txt
	fi

	

	NORMALIZED_TEST_LOCS=$( echo "$TOTAL_LINES_OF_TEST_CODE/$TOTAL_LINES_OF_APP_CODE" | bc -l )

	echo "	echo "$PROJ_NAME $NUMBER_TAGS_CURRENT_REPOSITORY $NUMBER_VTAG_TEST_FILES $TOTAL_LINES_OF_TEST_CODE $NORMALIZED_TEST_LOCS" >> $SCRIPT_FOLDER/$OUTPUT_FILE "

	#prints projname, NTR, NTC, TTL, TLR
	echo "$PROJ_NAME $NUMBER_TAGS_CURRENT_REPOSITORY $NUMBER_VTAG_TEST_FILES $TOTAL_LINES_OF_TEST_CODE $NORMALIZED_TEST_LOCS" >> $SCRIPT_FOLDER/$OUTPUT_FILE

	CURRENT=$(( $CURRENT + 1 ))

done < "$1"
