#script to compute metrics for projects with test files associated to the studied test frameworks

#input: $1 list with projects to search $2 keyword to search $3 starting folder = folder in which the cloned projects are located
#output: $keyword_classes.csv = .csv file with stats about test classes of a project, and their evolution; $keyword_releases.csv = .csv file with stats about the releases of a project, and the modifications in code, classes and methods between each release transition. script2results_$keyword.txt = averaged metrics for the final computations of metrics in the paper. All output files are located in the same folder of the script (i.e., $SCRIPT_FOLDER).



PROJECTS_LIST_FILE=$1		#full list of projects in which to search
KEYWORD_SEARCHED=$2		#tool keyword e.g. "espresso"
TOTAL_FILES_FOR_VERSION="0"


USERNAME="riccardocoppola"
PASSWORD="vazq20pa"

STARTING_FOLDER=$3
SCRIPT_FOLDER="$PWD"
echo $STARTING_FOLDER

echo "" > repositories_stats_$KEYWORD_SEARCHED.txt

echo "" > $STARTING_FOLDER/result_tmp.txt


rm -f $STARTING_FOLDER/previous_vtag_test_files.txt
rm -f $STARTING_FOLDER/current_vtag_test_files.txt







while read line; do

	echo "doing $line"

	PROJ_NAME=$line

	SKIP_ITER="0"
	CURRENT_PROJECT=$(( $CURRENT_PROJECT + 1))
	echo doing $CURRENT_PROJECT....


	SUM_TLR="0"
	PREVIOUS_TLR="0"
	SUM_MTLR="0"
	SUM_MRTL="0"
	SUM_TMR="0"

	SUM_MCR="0"
	SUM_MMR="0"
	SUM_FCR="0"
	SUM_RFCR="0"

	SUM_ADRR="0"
	NUM_FOR_AVG_MTLR="0"
	NUM_FOR_AVG_MRTL="0"
	NUM_FOR_AVG_TMR="0"
	NUM_FOR_AVG_MCR="0"
	NUM_FOR_AVG_FCR="0"
	NUM_FOR_AVG_MMR="0"
	NUM_FOR_AVG_RFCR="0"
	
	cd $STARTING_FOLDER/$PROJ_NAME
	git tag | xargs -I@ git log --format=format:"%ai @%n" -1 @ | sort | awk '{print $4}' > $STARTING_FOLDER/tags.txt
	echo "master" >> $STARTING_FOLDER/tags.txt
	NUMBER_VERSIONS=`cat $STARTING_FOLDER/tags.txt | wc -l`




	cd $STARTING_FOLDER

	mkdir -p $STARTING_FOLDER/_testfiles2/$PROJ_NAME/$KEYWORD_SEARCHED
	mkdir -p $STARTING_FOLDER/_totaldiffs2/$PROJ_NAME
	mkdir -p $STARTING_FOLDER/_totaldiffs2/$PROJ_NAME/

	echo "" > $STARTING_FOLDER/_testfiles2/$PROJ_NAME/$KEYWORD_SEARCHED.txt
	echo "" > $STARTING_FOLDER/_totaldiffs2/$PROJ_NAME/diffs.txt
	rm -f $STARTING_FOLDER/_totaldiffs2/$PROJ_NAME/all_test_files.txt 
	rm -f $STARTING_FOLDER/_totaldiffs2/$PROJ_NAME/test_files_history.txt 
	rm -f $STARTING_FOLDER/current_vtag_test_files_names.txt 
	rm -f $STARTING_FOLDER/previous_vtag_test_files_names.txt 


	NUMBER_VERSIONS_WITH_TESTS_CHANGED="0"				#for MRR
	NUMBER_VERSIONS_WITH_METHODS_CHANGED="0"			#for FRR
	NUMBER_VERSIONS_WITH_ADDED_DELETED_METHODS="0"			#for ADRR
	NUMBER_VERSIONS_WITH_TEST_CLASSES="0"				
	
	CURRENT_VERSION_NUMBER="0"


	while read vtag2; do



		ADDED_CLASSES="0"
		DELETED_CLASSES="0"
		MODIFIED_CLASSES="0"

		ADDED_METHODS="0"
		DELETED_METHODS="0"
		MODIFIED_METHODS="0"

		TOTAL_CLASSES_OLD=$TOTAL_CLASSES
		TOTAL_CLASSES="0"

		TOTAL_METHODS_OLD=$TOTAL_METHODS
		TOTAL_METHODS="0"

		CLASSES_WITH_MODIFIED_METHODS="0"
		PERCENTAGE_MOD_CLASSES="0"
		PERCENTAGE_MOD_METHODS="0"
		PERCENTAGE_MOD_CLASSES_W_MOD_METHODS="0"


		COUNT_FOR_ADRR="0"

		CURRENT_VERSION_NUMBER=$(( $CURRENT_VERSION_NUMBER + 1 ))
		echo "Version #$CURRENT_VERSION_NUMBER" >> $STARTING_FOLDER/_totaldiffs2/$PROJ_NAME/diffs.txt
		cd $STARTING_FOLDER/$PROJ_NAME
		git checkout $vtag2


		#full paths of test files
		rg -l -i "$KEYWORD_SEARCHED" $STARTING_FOLDER/$PROJ_NAME | awk -F "." '$NF == "java" {print $0}' >> $STARTING_FOLDER/_testfiles2/$PROJ_NAME/$KEYWORD_SEARCHED.txt  > $STARTING_FOLDER/current_vtag_test_files_prefilter.txt
		
		rm -f $STARTING_FOLDER/current_vtag_test_files.txt



		#additional checks	
	
		while read test_file; do
			
			#1 the file contains "test" in its path

			found_test=` echo $test_file | grep -i "test"  `
			if [ "$found_test" = "" ]; then
				echo "" 
			else
				found_keyword_after_comments=` cat $test_file | $SCRIPT_FOLDER/script.sed | grep "$KEYWORD_SEARCHED" `


				#2 the file, after all row and block comments are removed, contains anyway the keyword searched
				if [ "$found_keyword_after_comments" = "" ]; then
					echo ""
				else 
					echo $test_file >> $STARTING_FOLDER/current_vtag_test_files.txt
				fi						
			fi	



		done < $STARTING_FOLDER/current_vtag_test_files_prefilter.txt


		rm -f $STARTING_FOLDER/current_vtag_test_files_relative.txt
		while read test_file; do
			RELATIVE_PATH=${test_file//"$STARTING_FOLDER/$PROJ_NAME/"/}
			echo $RELATIVE_PATH >> $STARTING_FOLDER/current_vtag_test_files_relative.txt
		done < $STARTING_FOLDER/current_vtag_test_files.txt

		

		TOTAL_LINES_OF_APP_CODE=$(cloc --quiet `find . -name *.java` | awk '$1 == "Java" {print $3+$4+$5}')
		if [ $TOTAL_LINES_OF_APP_CODE == "" ]; then
			TOTAL_LINES_OF_APP_CODE="0"
		fi
		TOTAL_LINES_OF_TOOL_CODE="0"
		echo "Total lines of app code: $TOTAL_LINES_OF_APP_CODE" >> $STARTING_FOLDER/_totaldiffs2/$PROJ_NAME/diffs.txt #print stat
		

		NUMBER_VTAG_TEST_FILES_OLD="$NUMBER_VTAG_TEST_FILES"
		NUMBER_VTAG_TEST_FILES=`cat $STARTING_FOLDER/current_vtag_test_files.txt | wc -l`

		if [ $NUMBER_VTAG_TEST_FILES -ne 0 ]; then
			TOTAL_LINES_OF_TOOL_CODE=$(cloc --quiet `cat $STARTING_FOLDER/current_vtag_test_files.txt` | awk '$1 == "Java" {print $3+$4+$5}')

		fi

		
		if [ $TOTAL_LINES_OF_APP_CODE -eq "0" ]; then
			TLR="0"
		else		
			TLR=$( echo "$TOTAL_LINES_OF_TOOL_CODE / $TOTAL_LINES_OF_APP_CODE" | bc -l )
		fi
		SUM_TLR=$( echo "$SUM_TLR + $TLR" | bc -l )
		

		echo "Number of test files: $NUMBER_VTAG_TEST_FILES" >> $STARTING_FOLDER/_totaldiffs2/$PROJ_NAME/diffs.txt #print stat
		echo "Total lines of test code: $TOTAL_LINES_OF_TOOL_CODE" >> $STARTING_FOLDER/_totaldiffs2/$PROJ_NAME/diffs.txt #print stat



		if [ $TOTAL_LINES_OF_TOOL_CODE -ne "0" ]; then
			NUMBER_VERSIONS_WITH_TEST_CLASSES=$(( $NUMBER_VERSIONS_WITH_TEST_CLASSES + 1 ))
		fi


		rm -f $SCRIPT_FOLDER/old*

		cd $SCRIPT_FOLDER
		rename 's/new/old/' *.java
		cd $STARTING_FOLDER/$PROJ_NAME
		rm -f $SCRIPT_FOLDER/new*
		rm -f $SCRIPT_FOLDER/only_in_previous.txt
		rm -f $SCRIPT_FOLDER/only_in_current.txt
		rm -f $SCRIPT_FOLDER/common_test_files.txt
		PREVIOUS_VERSION_TEST_NUMBER=$NUMBER_VTAG_TEST_FILES



		if [ $SKIP_ITER -eq 0 ]; then

			SKIP_ITER="1"
			PREVIOUS_VERSION_TEST_NUMBER=$NUMBER_VTAG_TEST_FILES #storing current in previous

			#check of number of test methods in test classes
			while read test_file; do
					
				#test files considered as added in the first version of the app
				echo "A $test_file $CURRENT_VERSION_NUMBER" >> $STARTING_FOLDER/_totaldiffs2/$PROJ_NAME/test_files_history.txt


				ABSOLUTE_FILE_NAME=`cat $STARTING_FOLDER/current_vtag_test_files.txt | grep $test_file`
				RELATIVE_NAME_WITHOUT_SLASHES=`echo $test_file | tr "/" "_"`
				echo "$test_file" >> $STARTING_FOLDER/_totaldiffs2/$PROJ_NAME/all_test_files.txt

				cat $ABSOLUTE_FILE_NAME | sed '/^\s*$/d' > "$SCRIPT_FOLDER/new2_$RELATIVE_NAME_WITHOUT_SLASHES"
				$SCRIPT_FOLDER/script.sed < $SCRIPT_FOLDER/new2_$RELATIVE_NAME_WITHOUT_SLASHES > $SCRIPT_FOLDER/new_$RELATIVE_NAME_WITHOUT_SLASHES
				rm -f $SCRIPT_FOLDER/new2_$RELATIVE_NAME_WITHOUT_SLASHES

				METHODS_IN_ADDED_CLASS=`java -jar $SCRIPT_FOLDER/method_extractor.jar $SCRIPT_FOLDER/new_$RELATIVE_NAME_WITHOUT_SLASHES | wc -l`
				TOTAL_METHODS=$(( $TOTAL_METHODS + $METHODS_IN_ADDED_CLASS ))
				ADDED_METHODS=$(( $ADDED_METHODS + $METHODS_IN_ADDED_CLASS ))






				LINES_IN_FILE=`cat $ABSOLUTE_FILE_NAME | wc -l`
				echo "$line $vtag2 $test_file $LINES_IN_FILE - $METHODS_IN_ADDED_CLASS - - -" >> $SCRIPT_FOLDER/classes_$KEYWORD_SEARCHED.csv

			done < $STARTING_FOLDER/current_vtag_test_files_relative.txt



			cat $STARTING_FOLDER/current_vtag_test_files.txt > $STARTING_FOLDER/previous_vtag_test_files.txt
			cat $STARTING_FOLDER/current_vtag_test_files_names.txt > $STARTING_FOLDER/previous_vtag_test_files_names.txt
			cat $STARTING_FOLDER/current_vtag_test_files_relative.txt > $STARTING_FOLDER/previous_vtag_test_files_relative.txt
			PREVIOUS_TEST_TOTAL_LINES=$TOTAL_LINES_OF_TOOL_CODE
			PREVIOUS_TLR=$TLR
			vtag1=$vtag2


			echo "$line $vtag2 $TOTAL_LINES_OF_APP_CODE - $TOTAL_LINES_OF_TOOL_CODE - $NUMBER_VTAG_TEST_FILES - - - $TOTAL_METHODS - - - - $TLR - - - - - - -" >> $SCRIPT_FOLDER/results_releases_$KEYWORD_SEARCHED.csv

			continue

		fi


		TOTAL_LINES_MODIFIED=`git diff $vtag1 $vtag2 --numstat | grep ".java" | awk ' BEGIN { count=0 } { count+=$1+$2 } END { print count }'` 

		
		TEST_TOTAL_LINES_MODIFIED="0"



		

		while read test_file; do

			ABSOLUTE_FILE_NAME=`cat $STARTING_FOLDER/current_vtag_test_files.txt | grep $test_file`
			RELATIVE_NAME_WITHOUT_SLASHES=`echo $test_file | tr "/" "_"`


			cat $ABSOLUTE_FILE_NAME | sed '/^\s*$/d' > "$SCRIPT_FOLDER/new2_$RELATIVE_NAME_WITHOUT_SLASHES"
			$SCRIPT_FOLDER/script.sed < $SCRIPT_FOLDER/new2_$RELATIVE_NAME_WITHOUT_SLASHES > $SCRIPT_FOLDER/new_$RELATIVE_NAME_WITHOUT_SLASHES
			rm -f $SCRIPT_FOLDER/new2_$RELATIVE_NAME_WITHOUT_SLASHES

			METHODS_IN_CLASS=`java -jar $SCRIPT_FOLDER/method_extractor.jar $ABSOLUTE_FILE_NAME | wc -l`
			TOTAL_METHODS=$(( $TOTAL_METHODS + $METHODS_IN_CLASS ))



			ABSOLUTE_FILENAME_IN_PREVIOUS=`cat $STARTING_FOLDER/previous_vtag_test_files_relative.txt | grep "$test_file"`
			LINES_IN_FILE=`cat $ABSOLUTE_FILE_NAME | wc -l`


			if [ "$ABSOLUTE_FILENAME_IN_PREVIOUS" = "" ]; then
			
				echo $test_file > $SCRIPT_FOLDER/only_in_current.txt	
				echo "A $test_file $CURRENT_VERSION_NUMBER" >> $STARTING_FOLDER/_totaldiffs2/$PROJ_NAME/test_files_history.txt
				echo "$test_file" >> $STARTING_FOLDER/_totaldiffs2/$PROJ_NAME/all_test_files.txt
				ADDED_CLASSES=$(( $ADDED_CLASSES + 1 ))
				ADDED_METHODS=$(( $ADDED_METHODS + $METHODS_IN_CLASS ))


				echo "$line $vtag2 $test_file $LINES_IN_FILE - $METHODS_IN_CLASS - - -" >> $SCRIPT_FOLDER/classes_$KEYWORD_SEARCHED.csv
				COUNT_FOR_ADRR="1"

			else

				echo $test_file > $SCRIPT_FOLDER/common_test_files.txt
				ABSOLUTE_FILE_NAME=`cat $STARTING_FOLDER/current_vtag_test_files.txt | grep $test_file`
				echo "differences for file $test_file" `git diff $vtag1 $vtag2 --numstat | grep $test_file | awk ' BEGIN { count=0 } { count+=$1+$2 } END { print count }'` >> $STARTING_FOLDER/_totaldiffs2/$PROJ_NAME/diffs.txt
				TEST_LINES_MODIFIED=`git diff $vtag1 $vtag2 --numstat | grep $test_file | awk ' BEGIN { count=0 } { count+=$1+$2 } END { print count }'`
				TEST_TOTAL_LINES_MODIFIED=$(($TEST_TOTAL_LINES_MODIFIED + $TEST_LINES_MODIFIED))


				if [ $TEST_LINES_MODIFIED -ne 0 ]; then

					MODIFIED_CLASSES=$(( $MODIFIED_CLASSES + 1 ))
					echo "M $test_file $CURRENT_VERSION_NUMBER" >> $STARTING_FOLDER/_totaldiffs2/$PROJ_NAME/test_files_history.txt

					RELATIVE_NAME_WITHOUT_SLASHES=`echo $test_file | tr "/" "_"`
					diff $SCRIPT_FOLDER/old_$RELATIVE_NAME_WITHOUT_SLASHES $SCRIPT_FOLDER/new_$RELATIVE_NAME_WITHOUT_SLASHES > $SCRIPT_FOLDER/diff_$RELATIVE_NAME_WITHOUT_SLASHES.txt


					java -jar "$SCRIPT_FOLDER/method_extractor.jar" "$SCRIPT_FOLDER/old_$RELATIVE_NAME_WITHOUT_SLASHES" "$SCRIPT_FOLDER/new_$RELATIVE_NAME_WITHOUT_SLASHES" "$SCRIPT_FOLDER/diff_$RELATIVE_NAME_WITHOUT_SLASHES.txt" > $SCRIPT_FOLDER/tmp_parser_res.txt
					DELETED_METHODS_IN_CLASS=$(cat $SCRIPT_FOLDER/tmp_parser_res.txt | awk 'NR==1 {print $NF}')
					DELETED_METHODS=$(( $DELETED_METHODS + $DELETED_METHODS_IN_CLASS ))
					ADDED_METHODS_IN_CLASS=$(cat $SCRIPT_FOLDER/tmp_parser_res.txt | awk 'NR==2 {print $NF}')
					ADDED_METHODS=$(( $ADDED_METHODS + $ADDED_METHODS_IN_CLASS ))
					MODIFIED_METHODS_IN_CLASS=$(cat $SCRIPT_FOLDER/tmp_parser_res.txt | awk 'NR==3 {print $NF}')
					MODIFIED_METHODS=$(( $MODIFIED_METHODS + $MODIFIED_METHODS_IN_CLASS ))


					if [ $MODIFIED_METHODS_IN_CLASS -ne "0" ]; then
						CLASSES_WITH_MODIFIED_METHODS=$(( $CLASSES_WITH_MODIFIED_METHODS + 1 ))
						NUMBER_VERSIONS_WITH_METHODS_CHANGED=$(( $NUMBER_VERSIONS_WITH_METHODS_CHANGED + 1 ))
						echo "F $test_file $CURRENT_VERSION_NUMBER" >> $STARTING_FOLDER/_totaldiffs2/$PROJ_NAME/test_files_history.txt
					fi

					if [ $ADDED_METHODS_IN_CLASS -ne "0" ]; then
						COUNT_FOR_ADRR="1"
					fi
			
					if [ $DELETED_METHODS_IN_CLASS -ne "0" ]; then
						COUNT_FOR_ADRR="1"
					fi

					echo "$line $vtag2 $test_file $LINES_IN_FILE $TEST_LINES_MODIFIED $METHODS_IN_CLASS $ADDED_METHODS_IN_CLASS $DELETED_METHODS_IN_CLASS $MODIFIED_METHODS_IN_CLASS" >> $SCRIPT_FOLDER/classes_$KEYWORD_SEARCHED.csv

				else
					echo "$line $vtag2 $test_file $LINES_IN_FILE $TEST_LINES_MODIFIED $METHODS_IN_CLASS 0 0 0" >> $SCRIPT_FOLDER/classes_$KEYWORD_SEARCHED.csv
				fi
				


			fi





		done < $STARTING_FOLDER/current_vtag_test_files_relative.txt

		if [ $TEST_TOTAL_LINES_MODIFIED -ne "0" ]; then
			NUMBER_VERSIONS_WITH_TESTS_CHANGED=$(( $NUMBER_VERSIONS_WITH_TESTS_CHANGED + 1 ))
		fi


		MTLR="-"
		if [ $PREVIOUS_TEST_TOTAL_LINES -ne 0 ]; then
			MTLR=$( echo "$TEST_TOTAL_LINES_MODIFIED / $PREVIOUS_TEST_TOTAL_LINES" | bc -l )
			SUM_MTLR=$( echo "$SUM_MTLR + $MTLR" | bc -l )
			NUM_FOR_AVG_MTLR=$(( $NUM_FOR_AVG_MTLR + 1 ))
		fi





		MRTL="-"
		if [ $TOTAL_LINES_MODIFIED -ne "0" ]; then
			if [ $TOTAL_LINES_OF_TOOL_CODE -ne "0" ]; then
				MRTL=$( echo "$TEST_TOTAL_LINES_MODIFIED / $TOTAL_LINES_MODIFIED" | bc -l )
				SUM_MRTL=$( echo "$SUM_MRTL + $MRTL" | bc -l )
				NUM_FOR_AVG_MRTL=$(( $NUM_FOR_AVG_MRTL + 1 ))
			fi
		fi



		TMR="-"
		if [ $(echo "if ($PREVIOUS_TLR > 0) 1 else 0" | bc) -eq 1 ]; then	
			if [ $MRTL != "-" ]; then
				TMR=$( echo "$MRTL / $PREVIOUS_TLR" | bc -l )
				SUM_TMR=$( echo "$SUM_TMR + $TMR" | bc -l )
				NUM_FOR_AVG_TMR=$(( $NUM_FOR_AVG_TMR + 1 ))
			fi
		fi



		while read test_file; do


			ABSOLUTE_FILENAME_IN_CURRENT=`cat $STARTING_FOLDER/current_vtag_test_files.txt | grep $test_file`


			if [ "$ABSOLUTE_FILENAME_IN_CURRENT" = "" ]; then

				echo $test_file > $SCRIPT_FOLDER/only_in_previous.txt
				echo "D $test_file $CURRENT_VERSION_NUMBER" >> $STARTING_FOLDER/_totaldiffs2/$PROJ_NAME/test_files_history.txt
				
				DELETED_CLASSES=$(( $DELETED_CLASSES + 1 ))


				RELATIVE_NAME_WITHOUT_SLASHES=`echo $test_file | tr "/" "_"`
				METHODS_IN_DELETED_CLASS=`java -jar $SCRIPT_FOLDER/method_extractor.jar $SCRIPT_FOLDER/old_$RELATIVE_NAME_WITHOUT_SLASHES | wc -l`

				DELETED_METHODS=$(( $DELETED_METHODS + $METHODS_IN_DELETED_CLASS ))


				COUNT_FOR_ADRR="1"

			fi

		done < $STARTING_FOLDER/previous_vtag_test_files_relative.txt
		


		if [ $NUMBER_VTAG_TEST_FILES_OLD -eq 0 ]; then
			MCR="-"
			FCR="-"
		else
			MCR=$( echo "$MODIFIED_CLASSES / $NUMBER_VTAG_TEST_FILES_OLD" | bc -l)
			FCR=$( echo "$CLASSES_WITH_MODIFIED_METHODS / $NUMBER_VTAG_TEST_FILES_OLD" | bc -l)
			SUM_MCR=$( echo "$SUM_MCR + $MCR" | bc -l )
			SUM_FCR=$( echo "$SUM_FCR + $FCR" | bc -l )
			NUM_FOR_AVG_MCR=$(( $NUM_FOR_AVG_MCR + 1 ))
			NUM_FOR_AVG_FCR=$(( $NUM_FOR_AVG_FCR + 1 ))
		fi



		if [ $TOTAL_METHODS_OLD -eq 0 ]; then
			MMR="-"
		else
			MMR=$( echo "$MODIFIED_METHODS / $TOTAL_METHODS_OLD" | bc -l)
			SUM_MMR=$( echo "$SUM_MMR + $MMR" | bc -l )
			NUM_FOR_AVG_MMR=$(( $NUM_FOR_AVG_MMR + 1 ))
		fi



		if [ $MODIFIED_CLASSES -eq 0 ]; then
			RFCR="-"
		else
			RFCR=$( echo "$CLASSES_WITH_MODIFIED_METHODS / $MODIFIED_CLASSES" | bc -l)
			SUM_RFCR=$( echo "$SUM_RFCR + $RFCR" | bc -l )
			NUM_FOR_AVG_RFCR=$(( $NUM_FOR_AVG_RFCR + 1 ))
		fi



		SUM_ADRR=$(( $SUM_ADRR + $COUNT_FOR_ADRR ))


		

		cat $STARTING_FOLDER/current_vtag_test_files.txt > $STARTING_FOLDER/previous_vtag_test_files.txt
		cat $STARTING_FOLDER/current_vtag_test_files_names.txt > $STARTING_FOLDER/previous_vtag_test_files_names.txt
		cat $STARTING_FOLDER/current_vtag_test_files_relative.txt > $STARTING_FOLDER/previous_vtag_test_files_relative.txt
		PREVIOUS_TEST_TOTAL_LINES=$TOTAL_LINES_OF_TOOL_CODE
		PREVIOUS_TLR=$TLR
		vtag1=$vtag2

		echo "$line $vtag2 $TOTAL_LINES_OF_APP_CODE $TOTAL_LINES_MODIFIED $TOTAL_LINES_OF_TOOL_CODE $TEST_TOTAL_LINES_MODIFIED $NUMBER_VTAG_TEST_FILES $ADDED_CLASSES $DELETED_CLASSES $MODIFIED_CLASSES $TOTAL_METHODS $ADDED_METHODS $DELETED_METHODS $MODIFIED_METHODS $CLASSES_WITH_MODIFIED_METHODS $TLR $MTLR $MRTL $TMR $MCR $MMR $RFCR $FCR" >> $SCRIPT_FOLDER/results_releases_$KEYWORD_SEARCHED.csv
		
	done < $STARTING_FOLDER/tags.txt


	

	
	AVG_TLR=$( echo "$SUM_TLR / $NUMBER_VERSIONS" | bc -l )


	if [ $NUMBER_VERSIONS -eq 1 ]; then
		echo ""
	else
		NUMBER_VERSIONS_FOR_AVGS=$(( $NUMBER_VERSIONS - 1 ))
		MRR=$(echo "$NUMBER_VERSIONS_WITH_TESTS_CHANGED / $NUMBER_VERSIONS_FOR_AVGS" | bc -l )
		FRR=$(echo "$NUMBER_VERSIONS_WITH_METHODS_CHANGED / $NUMBER_VERSIONS_FOR_AVGS" | bc -l )
		ADRR=$(echo "$SUM_ADRR / $NUMBER_VERSIONS_FOR_AVGS" | bc -l )
	fi


	if [ $NUM_FOR_AVG_MTLR -ne 0 ]; then
		AVG_MTLR=$(echo "$SUM_MTLR / $NUM_FOR_AVG_MTLR" | bc -l )
	else
		AVG_MTLR="-"
	fi

	if [ $NUM_FOR_AVG_MRTL -ne 0 ]; then
		AVG_MRTL=$(echo "$SUM_MRTL / $NUM_FOR_AVG_MRTL" | bc -l )
	else
		AVG_MRTL="-"
	fi

	if [ $NUM_FOR_AVG_TMR -ne 0 ]; then
		AVG_TMR=$(echo "$SUM_MTLR / $NUM_FOR_AVG_TMR" | bc -l )
	else
		AVG_TMR="-"
	fi

	if [ $NUM_FOR_AVG_MCR -ne 0 ]; then
		AVG_MCR=$(echo "$SUM_MCR / $NUM_FOR_AVG_MCR" | bc -l )
	else
		AVG_MCR="-"
	fi

	if [ $NUM_FOR_AVG_MMR -ne 0 ]; then
		AVG_MMR=$(echo "$SUM_MMR / $NUM_FOR_AVG_MMR" | bc -l )
	else
		AVG_MMR="-"
	fi

	if [ $NUM_FOR_AVG_FCR -ne 0 ]; then
		AVG_FCR=$(echo "$SUM_FCR / $NUM_FOR_AVG_FCR" | bc -l )
	else
		AVG_FCR="-"
	fi

	if [ $NUM_FOR_AVG_RFCR -ne 0 ]; then
		AVG_RFCR=$(echo "$SUM_RFCR / $NUM_FOR_AVG_RFCR" | bc -l )
	else
		AVG_RFCR="-"
	fi



	#LIFESPANS AND VOLATILITY COMPUTATIONS (for metrics TSV, TSF) + creation of file classes.csv


	cd $STARTING_FOLDER

	mkdir -p _totaldiffs2/$PROJ_NAME/test_stories/
	cat _totaldiffs2/$PROJ_NAME/all_test_files.txt > list_of_test_names.txt
	sort list_of_test_names.txt | uniq > unique_test_names.txt


	NUMBER_OF_TEST_FILES=`cat unique_test_names.txt | wc -l`


	SUM_LIFESPANS_NEW="0"

	FRAGILE_CLASSES="0"
	VOLATILE_CLASSES="0"

	VOLATILITY_SUM="0"

	while read test_class; do
		RELATIVE_NAME_WITHOUT_SLASHES=`echo $test_class | tr "/" "_"`
		cat _totaldiffs2/$PROJ_NAME/test_files_history.txt | grep $test_class >_totaldiffs2/$PROJ_NAME/test_stories/$RELATIVE_NAME_WITHOUT_SLASHES.txt

		VERSION_ADDED=`cat _totaldiffs2/$PROJ_NAME/test_stories/$RELATIVE_NAME_WITHOUT_SLASHES.txt | head -n 1 | awk '{ print $NF }'`
		VERSION_LAST_MODIFIED=`cat _totaldiffs2/$PROJ_NAME/test_stories/$RELATIVE_NAME_WITHOUT_SLASHES.txt | tail -n 1 | awk '{ print $NF }'`

		VERSION_LAST_PRESENT=$NUMBER_VERSIONS
		LAST_ACTION=`cat _totaldiffs2/$PROJ_NAME/test_stories/$RELATIVE_NAME_WITHOUT_SLASHES.txt | tail -n 1 | awk ' { print $1 } '`
		if [ "$LAST_ACTION" = "D" ]; then
			VERSION_LAST_PRESENT=$(cat _totaldiffs2/$PROJ_NAME/test_stories/$RELATIVE_NAME_WITHOUT_SLASHES.txt | tail -n 1 | awk ' { print $3 } ')
			#echo "$test_class added in $VERSION_ADDED deleted in $VERSION_LAST_PRESENT"
			LIFESPAN_NEW=$(($VERSION_LAST_PRESENT - $VERSION_ADDED))
		else
			#echo "$test_class added in $VERSION_ADDED deleted in $VERSION_LAST_PRESENT"
			LIFESPAN_NEW=$( echo "1 + $NUMBER_VERSIONS - $VERSION_ADDED" | bc -l )
		fi

		RELATIVE_LIFESPAN_NEW=$( echo "$LIFESPAN_NEW / $NUMBER_VERSIONS" | bc -l )


	
		NUM_MODIFICATIONS=` cat _totaldiffs2/$PROJ_NAME/test_stories/$RELATIVE_NAME_WITHOUT_SLASHES.txt | awk ' $1 == "M" { sum+=1 } END { print sum }'`
		if [ "$NUM_MODIFICATIONS" = "" ]; then
			NUM_MODIFICATIONS="0"
		fi

		NUM_FRAGILITIES=` cat _totaldiffs2/$PROJ_NAME/test_stories/$RELATIVE_NAME_WITHOUT_SLASHES.txt | awk ' $1 == "F" { sum+=1 } END { print sum }'`
		if [ "$NUM_FRAGILITIES" = "" ]; then
			NUM_FRAGILITIES="0"
		fi

		if [ $NUM_MODIFICATIONS -ne 0 ]; then
			VOLATILE_CLASSES=$(( $VOLATILE_CLASSES + 1 ))
		fi
		if [ $NUM_FRAGILITIES -ne 0 ]; then
			FRAGILE_CLASSES=$(( $FRAGILE_CLASSES + 1 ))
		fi


		VOLATILITY=$( echo " $NUM_MODIFICATIONS / $LIFESPAN_NEW " | bc -l )
		VOLATILITY_SUM=$( echo " $VOLATILITY_SUM + $VOLATILITY " | bc -l )



	done < unique_test_names.txt



	if [ $NUMBER_OF_TEST_FILES -ne 0 ]; then
		AVERAGE_VOLATILITY=$(echo "$VOLATILITY_SUM / $NUMBER_OF_TEST_FILES" | bc -l )
		TSV=$( echo " $FRAGILE_CLASSES / $NUMBER_OF_TEST_FILES " | bc -l )
		TSF=$( echo " $VOLATILE_CLASSES / $NUMBER_OF_TEST_FILES " | bc -l )
	else
		TSV="-"
		TSF="-"
	fi
	

	#final results


	echo "$line $AVG_TLR $AVG_MTLR $AVG_MRTL $AVG_TMR $MRR $TSV $AVG_MCR $AVG_MMR $AVG_FCR $AVG_RFCR $FRR $ADRR $TSF" >> $SCRIPT_FOLDER/script2_results_$KEYWORD_SEARCHED.txt


done < $PROJECTS_LIST_FILE


rm -f $SCRIPT_FOLDER/old_*
rm -f $SCRIPT_FOLDER/new_*
rm -f $SCRIPT_FOLDER/diff_*
